#	sound_dos.tcl	-	Reserved Word DoS detection and elimination
set sd_version "0.02a"
#	This is a stand-alone script that can be added to just about
#	any eggdrop bot.  

#	Thanks to slennox at www.eggheads.org and the other guys that
#	contributed the starting code for it.
#	-`WarpKat

#	Version	Information regarding changes and stuff...
#	-------	-----------------------------------------------------------------------------------------------
#	v0.01b	Initial release detects for CTCP SOUND con/con - don't remember when I released it but it works
#	v0.01c	Released 2001-09-17
#		REVAMP!!!!!!!!  WOOHOO!!!!!!!!!!!!!!!
#		Included support for Undernet X/W Channel Services.
#		Banmask changed to this format:  *!*ident... instead of *!ident... to better enforce bans.
#		Code was revamped to do better string pattern matching against reserved words.  I got sick
#			of recreating the string match "*blah/blah*" stuff.
#	v0.01d	Released 2001-09-17
#		Minor bugfix - no longer reports TCL error when looking for $match1 or $match2 variables
#			These variables have been eliminated and replaced with a counter.
#	v0.01e	Released 2001-09-18
#		Major bugfix - previous version banned anyone for any CTCP sound event...sorry about that!  =:D
#	v0.01f	Released 2001-09-19
#		Recoded the counters so they are seperated...for some reason this seems to work better.
#		Also included the actual event in the ban that was played; enclosed in ()'s.
#		The script seems to be a bit slower, however, it is accurate and thorough as far as I'm aware,
#			plus, if the person leaves the channel before the ban is initiated, the person is still
#			nailed...so this is a good thing, I hope...
#	v0.02a	Released 2001-09-20 (Test Release)
#		Added detection for comic chat alternative delivery method of con/con (e.g. # Appears as con/aux.wav)
#		Removed comments to make the code look neater
#
#	Set the list of reserved words here.  Microsoft is notorious for leaving these exploitable and users
#	still have not gotten the patches they need.  In the future, this script will remember the hostmasks
#	of people that were nailed by the exploit and will message them on return with two URL's for the patch.
#	If you have any other reserved words that aren't listed here but cause the BSoD on unpatched Windows
#	machines, put it at the end and notify me at warpkat2001@yahoo.com so I can include it in all
#	future releases.

set RWords {
	"io"
	"con"
	"aux"
	"nul"
	"prn"
	"clock\$"
	"com1"
	"com2"
	"com3"
	"com4"
	"lpt1"
	"lpt2"
	"lpt3"
	"config\$"
	"msdos"
	"ncc-cd01"
	"xmsxxxx0"
	"ifs\$hlp\$"
	"setverxx"
	"win"
	"vmm32"
	"command"
	"mem"
}

# The bind		Event			Proc to call
# -----------		--------------		------------
bind ctcp 	-	SOUND			soundcheck
bind pubm	-	*			comicRword

set sd_counter1 0
set sd_counter2 0

proc userbanmask {uhost} {
	set ident [string range $uhost [expr [string first ! $uhost]+1] [expr [string last @ $uhost]-1]]
	return "*!*$ident[string range [maskhost $uhost] [string first @ [maskhost $uhost]] e]"
}

proc comicRword { nick uhost handle dest arg } {
	global botnick RWords sd_counter1 sd_counter2
	if { [string match "# Appears *" $arg] } {
		foreach { word1 } $RWords {
			if {
			    	( [string match "*$word1/*" [string tolower $arg]] )
			} {
				set sd_counter1 1
			}
		}
		foreach { word2 } $RWords {
			if {
		    		( [string match "*/$word2*" [string tolower $arg]] )
		    	} {
				set sd_counter2 1
			}
		}
		if {
			$sd_counter1 == 1
		&&	$sd_counter2 == 1
		} {
			newchanban $dest [userbanmask $uhost] $botnick "Reserved Word Denial of Service attack detected by $nick - ($arg)" 120
			putserv "KICK $dest $nick :Reserved Word Denial of Service attack detected - banned."
			putserv "PRIVMSG $dest :$nick has attempted a Reserved Word Denial of Service attack on this channel.  Ban has been initiated. ($arg)"
#			putserv "PRIVMSG k9@k9.chatnet.org :ban $dest $nick Reserved Word Denial of Service attack detected - banned. ($arg)"
#			putserv "PRIVMSG X :ban $dest $nick Reserved Word Denial of Service attack detected - banned. ($arg)"
			putserv "PRIVMSG #litterbox :$nick ($uhost) has attempted a Reserved Word Denial of Service attack in $dest. A ban on $uhost has been initiated.  The form of the CTCP SOUND event was \002$arg\002"
		}
		set sd_counter1 0
		set sd_counter2 0
	}

}

proc soundcheck { nick uhost handle dest key arg } {
	global botnick RWords sd_counter1 sd_counter2
	foreach { word1 } $RWords {
		if {
		    	( [string match "*$word1/*" [string tolower $arg]] )
		} {
			set sd_counter1 1
		}
	}
	foreach { word2 } $RWords {
		if {
	    		( [string match "*/$word2*" [string tolower $arg]] )
	    	} {
			set sd_counter2 1
		}
	}
	if {
		$sd_counter1 == 1
	&&	$sd_counter2 == 1
	} {
		newchanban $dest [userbanmask $uhost] $botnick "Reserved Word Denial of Service attack detected by $nick - ($arg)" 120
		putserv "KICK $dest $nick :Reserved Word Denial of Service attack detected - banned."
		putserv "PRIVMSG $dest :$nick has attempted a Reserved Word Denial of Service attack on this channel.  Ban has been initiated. ($arg)"
#		putserv "PRIVMSG k9@k9.chatnet.org :ban $dest $nick Reserved Word Denial of Service attack detected - banned. ($arg)"
#		putserv "PRIVMSG X :ban $dest $nick Reserved Word Denial of Service attack detected - banned. ($arg)"
		putserv "PRIVMSG #litterbox :$nick ($uhost) has attempted a Reserved Word Denial of Service attack in $dest. A ban on $uhost has been initiated.  The form of the CTCP SOUND event was \002$arg\002"
	}

	set sd_counter1 0
	set sd_counter2 0

}

putlog "Sound_DoS v$sd_version by `WarpKat <warpkat2001@yahoo.com> loaded...channels now protected against reserved word exploits."

